CSIT-1264: Add oper branch wrapper entry script
[csit.git] / resources / libraries / bash / entry / per_patch_perf.sh
1 #!/usr/bin/env bash
2
3 # Copyright (c) 2018 Cisco and/or its affiliates.
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at:
7 #
8 #     http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16 set -exuo pipefail
17
18 # This entry script does not change CSIT branch,
19 # use "with_oper_for_vpp.sh" wrapper for that.
20 #
21 # Assumptions:
22 # + There is a directory holding VPP repo with patch under test checked out.
23 # + It contains csit subdirectory with CSIT code to use (this script is there).
24 # + Everything needed to build VPP is already installed locally.
25 # Consequences:
26 # + At the end, VPP repo has parent commit checked out and built.
27 # + Directories build_root, dpdk and csit are reset during the run.
28 # + The following directories (relative to VPP repo) are (re)created:
29 # ++ csit_new, csit_parent, build_new, build_parent,
30 # ++ archive, csit/archive, csit_download_dir.
31
32 # TODO: Implement some kind of VPP build caching.
33
34 # "set -eu" handles failures from the following two lines.
35 BASH_ENTRY_DIR="$(dirname $(readlink -e "${BASH_SOURCE[0]}"))"
36 BASH_FUNCTION_DIR="$(readlink -e "${BASH_ENTRY_DIR}/../function")"
37 source "${BASH_FUNCTION_DIR}/common.sh" || {
38     echo "Source failed." >&2
39     exit 1
40 }
41 source "${BASH_FUNCTION_DIR}/per_patch.sh" || die "Source failed."
42 common_dirs || die
43 set_perpatch_vpp_dir || die
44 build_vpp_ubuntu_amd64 "NEW" || die
45 prepare_build_parent || die
46 build_vpp_ubuntu_amd64 "PARENT" || die
47 prepare_test_new || die
48 ## Replace previous 4 lines with this to speed up testing.
49 #download_builds "REPLACE_WITH_URL" || die
50 get_test_tag_string || die
51 get_test_code "${1-}" || die
52 set_perpatch_dut || die
53 select_topology || die
54 activate_virtualenv "${VPP_DIR}" || die
55 reserve_testbed || die
56 select_tags || die
57 compose_pybot_arguments || die
58 check_download_dir || die
59 run_pybot "10" || die
60 copy_archives || die
61 die_on_pybot_error || die
62 prepare_test_parent || die
63 check_download_dir || die
64 run_pybot "10" || die
65 untrap_and_unreserve_testbed || die
66 copy_archives || die
67 die_on_pybot_error || die
68 compare_test_results  # The error code becomes this script's error code.
69 # TODO: After merging, make sure archiving works as expected.